 ; WARNING : All of functions may change EAX register !
 .386p


 b       equ byte ptr
 w       equ word ptr
 d       equ dword ptr
 f       equ fword ptr
 o       equ offset

 Code32 Segment Para Public Use32 'Code'
 Assume CS : Code32, DS : Code32, ES : Code32, SS : Code32
  extrn _NEAR_CLIP:dword
 include !libs\engine\engine.inc








;****************************************************************************
;*  FLOAT  VectorDot(vector u, vector v);
;*
;*  Description: Function calculates vector dot product
;*
;*  In  : stack as below
;*        st0  st1  st2  st3  st4  st5
;*        u.x  u.y  u.z  v.x  v.y  v.z
;*
;*  Out : st(0) contains result of operation
;****************************************************************************
 VectorDot_:
    fld     d [esp.vec_y            + 4]
    fmul    d [esp.vec_y + vec_size + 4]
    fld     d [esp.vec_x            + 4]
    fmul    d [esp.vec_x + vec_size + 4]
    faddp   st(1), st(0)
    fld     d [esp.vec_z            + 4]
    fmul    d [esp.vec_z + vec_size + 4]
    faddp   st(1), st(0)
    ret     18h

;****************************************************************************
;*  void VectorCross(vector u, vector v, vector *result);
;*
;*  Description: Function calculates vector cross product
;*
;*  In  : stack as below
;*        u.x u.y u.z v.x v.y v.z pointer_to_result
;*
;*  Out : *result contains result of operation
;****************************************************************************
 VectorCross_:
    ; res.x = (u.y * v.z) - (u.z * v.y);
    ; res.y = (u.z * v.x) - (u.x * v.z);
    ; res.z = (u.x * v.y) - (u.y * v.x);
    ;                                     st0     st1     st2     st3     st4     st5  st6  st7
    fld     d [esp.vec_y            + 4]; u.y
    fmul    d [esp.vec_z + vec_size + 4]; u.y*v.z
    fld     d [esp.vec_z            + 4]; u.z     u.y*v.z
    fmul    d [esp.vec_y + vec_size + 4]; u.z*v.y u.y*v.z
    fld     d [esp.vec_z            + 4]; u.z     u.z*v.y u.y*v.z
    fmul    d [esp.vec_x + vec_size + 4]; u.z*v.x u.z*v.y u.y*v.z
    fxch    st(1)                       ; u.z*v.y u.z*v.x u.y*v.z
    fsubp   st(2), st(0)                ; u.z*v.x res.x
    mov     eax, d [esp + 01ch]
    fld     d [esp.vec_x            + 4]; u.x     u.z*v.x res.x
    fmul    d [esp.vec_z + vec_size + 4]; u.x*v.z u.z*v.x res.x
    fld     d [esp.vec_x            + 4]; u.x     u.x*v.z u.z*v.x res.x
    fmul    d [esp.vec_y + vec_size + 4]; u.x*v.y u.x*v.z u.z*v.x res.x
    fxch    st(1)                       ; u.x*v.z u.x*v.y u.z*v.x res.x
    fsubp   st(2), st(0)                ; u.x*v.y res.y   res.x
    fxch    st(2)                       ; res.x   res.y   u.x*v.y
    fstp    d [eax]                     ; res.y   u.x*v.y
    fld     d [esp.vec_y            + 4]; u.y     res.y   u.x*v.y
    fmul    d [esp.vec_x + vec_size + 4]; u.y*v.x res.y   u.x*v.y
    fxch    st(1)                       ; res.y   u.y*v.x u.x*v.y
    fstp    d [eax + 4]                 ; u.y*v.x u.x*v.y
    fsubp   st(1), st(0)                ; res.z
    fstp    d [eax + 8]
    ret     1ch

;****************************************************************************
;*  FLOAT VectorLength(vector u)
;*
;*  Description: Function calculates length of vector
;*
;*  In  : stack as below
;*        u.x u.y u.z
;*
;*  Out : st(0) contains length of vector
;****************************************************************************
VectorLength_:
    fld     d [esp.vec_y + 4]
    fmul    st, st(0)
    fld     d [esp.vec_x + 4]
    fmul    st, st(0)
    faddp   st(1), st(0)
    fld     d [esp.vec_z + 4]
    fmul    st, st(0)
    faddp   st(1), st(0)
    fsqrt
    ret     0ch

;****************************************************************************
;*  void VectorNormalize(vector *u)
;*
;*  Description: Function normalizes vector
;*
;*  In  : EAX - pointer to vector
;*
;*  Out : *u is normalized
;****************************************************************************
VectorNormalize_:
    push    ebp
    mov     ebp, esp
    sub     esp, 8
    mov     d [esp-8+8], eax
    mov     eax, d [esp-8+8]
    push    d [eax+8H]
    mov     eax, d [esp-8+8+4]
    push    d [eax+4H]
    mov     eax, d [esp-8+8+4+4]
    push    d [eax]
    call     VectorLength_
    fstp    d [esp-4+8]
    test    d [esp-4+8],7fffffffH
    je      short vn_l1
    mov     eax, d [esp-8+8]
    fld     d [eax]
    fdiv    d [esp-4+8]
    fstp    d [eax]
    mov     eax, d [esp-8+8]
    fld     d [eax+4H]
    fdiv    d [esp-4+8]
    fstp    d [eax+4]
    mov     eax, d [esp-8+8]
    fld     d [eax+8H]
    fdiv    d [esp-4+8]
    fstp    d [eax+8H]
    jmp     short vn_l2
vn_l1:
    mov     eax, d [esp-8+8]
    mov     d [eax], 0
    mov     eax, d [esp-8+8]
    mov     d [eax + 4], 0
    mov     eax, d [esp-8+8]
    mov     d [eax+8], 0
vn_l2:
    mov     esp, ebp
    pop     ebp
    ret

;****************************************************************************
;*  void VectorCreate(vector u, vector v, vector *result)
;*
;*  Description: Function creates vector from two points
;*
;*  In  : stack as below
;*        u.x u.y u.z v.x v.y v.z pointer_to_result
;*
;*  Out : None
;****************************************************************************
VectorCreate_:
    mov     eax, d [esp+1ch]
    fld     d [esp.vec_x + vec_size + 4]; v.x
    fsub    d [esp.vec_x            + 4]; u.x
    fstp    d [eax]
    fld     d [esp.vec_y + vec_size + 4]; v.y
    fsub    d [esp.vec_y            + 4]; u.y
    fstp    d [eax + 4]
    fld     d [esp.vec_z + vec_size + 4]; v.z
    fsub    d [esp.vec_z            + 4]; u.z
    fstp    d [eax + 8]
    ret     1ch

;****************************************************************************
;*  void MatrixCopy(matrix mtx1, matrix mtx2)
;*
;*  Description: Function copies one matrix to another
;*
;*  In  : EDX - source matrix
;*        EAX - target matrix
;*
;*  Out : None
;****************************************************************************
MatrixCopy_:
    push    esi
    push    edi
    push    ecx
    mov     esi, edx
    mov     edi, eax
    mov     ecx, 16
    rep     movsd
    pop     ecx
    pop     edi
    pop     esi
    ret

;****************************************************************************
;*  void MakePerspective(vector *p3d, vertex2d *p2d, UDWORD count)
;*
;*  Description: Function transform 3d point to 2d point
;*
;*  In  : EAX - pointer to 3d points
;*        EDX - pointer to 2d points
;*        EBX - number of points
;*
;*  Out : None
;****************************************************************************
 MakePerspective_:
    push    edx
    push    ebx
 mp_petla:
    cmp     d [eax.vec_z], 0
    jz      mp_bez_tego_punktu
    ;                       st0      st1      st2      st3      st4
    fld     d [eax.vec_x] ; x3d
    fmul    d [Scale8_4]  ; x3d*4096
    fld     d [eax.vec_y] ; y3d      x3d*4096
    fmul    d [Scale8_4]  ; y3d*4096 x3d*4096
    fld     d [eax.vec_z] ; z3d      y3d*4096 x3d*4096
    fdiv    st(2), st(0)  ; z3d      y3d*4096 prawie_x
    fld     d [X_Centre]  ; 160*16   z3d      y3d*4096 prawie_x
    fld     d [Y_Centre]  ; 100*16   160*16   z3d      y3d*4096 prawie_x
    fxch    st(2)         ; z3d      160*16   100*16   y3d*4096 prawie_x
    fdiv    st(3), st(0)  ; z3d      160*16   100*16   prawie_y prawie_x
    fxch    st(1)         ; 160*16   z3d      100*16   prawie_y prawie_x
    faddp   st(4), st(0)  ; z3d      100*16   prawie_y x2d
    fxch    st(1)         ; 100*16   z3d      prawie_y x2d
    faddp   st(2), st(0)  ; z3d      y2d      x2d
    fstp    d [edx.vert_z]; y2d      x2d
    fxch    st(1)         ; x2d      y2d
    add     eax, vec_size
    frndint
    fistp   d [edx.vert_x]; y2d
    frndint
    fistp   d [edx.vert_y]
    add     edx, vert2d_size
 mp_bez_tego_punktu:
    dec     ebx
    jnz     mp_petla
    pop     ebx
    pop     edx
    ret

;****************************************************************************
;*  void MatrixMultiply(matrix a, matrix b, matrix out)
;*
;*  Description: Function multiplies two matrices
;*
;*  In  : EAX - pointer to a
;*        EDX - pointer to b
;*        EBX - pointer to out
;*
;*  Out : None
;****************************************************************************
MatrixMultiply_:
    ;                              st0      st1      st2     st3      st4     st5
    fld     d [eax]               ;a00
    fmul    d [edx]               ;a00*b00
    fld     d [eax + 1*4]         ;a01      a00*b00
    fld     d [eax + 2*4]         ;a02      a01      a00*b00
    fmul    d [edx + 2*4*4]       ;a02*b20  a01      a00*b00
    fxch    st(1)                 ;a01      a02*b20  a00*b00
    fmul    d [edx + 1*4*4]       ;a01*b10  a02*b20  a00*b00
    fxch    st(2)                 ;a00*b00  a02*b20  a01*b10
    faddp   st(1), st(0)          ;prawie00 a01*b10
    fld     d [eax]               ;a00      prawie00 a01*b10
    fmul    d [edx + 1*4]         ;a00*b01  prawie00 a01*b10
    fxch    st(2)                 ;a01*b10  prawie00 a00*b01
    faddp   st(1), st(0)          ;temp00   a00*b01
    fld     d [eax + 1*4]         ;a01      temp00   a00*b01
    fld     d [eax + 2*4]         ;a02      a01      temp00  a00*b01
    fmul    d [edx + 2*4*4 + 1*4] ;a02*b21  a01      temp00  a00*b01
    fxch    st(1)                 ;a01      a02*b21  temp00  a00*b01
    fmul    d [edx + 1*4*4 + 1*4] ;a01*b11  a02*b21  temp00  a00*b01
    fxch    st(3)                 ;a00*b01  a02*b21  temp00  a01*b11
    faddp   st(1), st(0)          ;prawie01 temp00   a01*b11
    fld     d [eax]               ;a00      prawie01 temp00  a01*b11
    fmul    d [edx + 2*4]         ;a00*b02  prawie01 temp00  a01*b11
    fxch    st(3)                 ;a01*b11  prawie01 temp00  a00*b02
    faddp   st(1), st(0)          ;temp01   temp00   a00*b02
    fld     d [eax + 1*4]         ;a01      temp01   temp00   a00*b02
    fld     d [eax + 2*4]         ;a02      a01      temp01   temp00  a00*b02
    fmul    d [edx + 2*4*4 + 2*4] ;a02*b22  a01      temp01   temp00  a00*b02
    fld     d [Value_0]           ;0.0      a02*b22  a01      temp01  temp00  a00*b02
    fxch    st(5)                 ;a00*b02  a02*b22  a01      temp01  temp00  0.0
    faddp   st(1), st(0)          ;prawie02 a01      temp01   temp00  0.0
    fxch    st(1)                 ;a01      prawie02 temp01   temp00  0.0
    fmul    d [edx + 1*4*4 + 2*4] ;a01*b12  prawie02 temp01   temp00  0.0
    faddp   st(1), st(0)          ;temp02   temp01   temp00   0.0
    fxch    st(2)                 ;temp00   temp01   temp02   0.0
    fstp    d [o temp_mtx]        ;temp01   temp02   0.0
    fstp    d [o temp_mtx + 1*4]  ;temp02   0.0
    fstp    d [o temp_mtx + 2*4]  ;0.0
    fstp    d [o temp_mtx + 3*4]


    fld     d [eax + 1*4*4]       ;a10
    fmul    d [edx]               ;a10*b00
    fld     d [eax + 1*4 + 1*4*4] ;a11      a10*b00
    fld     d [eax + 2*4 + 1*4*4] ;a12      a11      a10*b00
    fmul    d [edx + 2*4*4]       ;a12*b20  a11      a10*b00
    fxch    st(1)                 ;a11      a12*b20  a10*b00
    fmul    d [edx + 1*4*4]       ;a11*b10  a12*b20  a10*b00
    fxch    st(2)                 ;a10*b00  a12*b20  a11*b10
    faddp   st(1), st(0)          ;prawie10 a11*b10
    fld     d [eax + 1*4*4]       ;a10      prawie10 a11*b10
    fmul    d [edx + 1*4]         ;a10*b01  prawie10 a11*b10
    fxch    st(2)                 ;a11*b10  prawie10 a10*b01
    faddp   st(1), st(0)          ;temp10   a10*b01
    fld     d [eax + 1*4 + 1*4*4] ;a11      temp10   a10*b01
    fld     d [eax + 2*4 + 1*4*4] ;a12      a11      temp10  a10*b01
    fmul    d [edx + 2*4*4 + 1*4] ;a12*b21  a11      temp10  a10*b01
    fxch    st(1)                 ;a11      a12*b21  temp10  a10*b01
    fmul    d [edx + 1*4*4 + 1*4] ;a11*b11  a12*b21  temp10  a10*b01
    fxch    st(3)                 ;a10*b01  a12*b21  temp10  a11*b11
    faddp   st(1), st(0)          ;prawie11 temp10   a11*b11
    fld     d [eax + 1*4*4]       ;a10      prawie11 temp10  a11*b11
    fmul    d [edx + 2*4]         ;a10*b02  prawie11 temp10  a11*b11
    fxch    st(3)                 ;a11*b11  prawie11 temp10  a10*b02
    faddp   st(1), st(0)          ;temp11   temp10   a10*b02
    fld     d [eax + 1*4 + 1*4*4] ;a11      temp11   temp10   a10*b02
    fld     d [eax + 2*4 + 1*4*4] ;a12      a11      temp11   temp10  a10*b02
    fmul    d [edx + 2*4*4 + 2*4] ;a12*b22  a11      temp11   temp10  a10*b02
    fld     d [Value_0]           ;0.0      a12*b22  a11      temp11  temp10  a10*b02
    fxch    st(5)                 ;a10*b02  a12*b22  a11      temp11  temp10  0.0
    faddp   st(1), st(0)          ;prawie12 a11      temp11   temp10  0.0
    fxch    st(1)                 ;a11      prawie12 temp11   temp10  0.0
    fmul    d [edx + 1*4*4 + 2*4] ;a11*b12  prawie12 temp11   temp10  0.0
    faddp   st(1), st(0)          ;temp12   temp11   temp10   0.0
    fxch    st(2)                 ;temp10   temp11   temp12   0.0
    fstp    d [o temp_mtx + 1*4*4]       ;temp11   temp12   0.0
    fstp    d [o temp_mtx + 1*4 + 1*4*4] ;temp12   0.0
    fstp    d [o temp_mtx + 2*4 + 1*4*4] ;0.0
    fstp    d [o temp_mtx + 3*4 + 1*4*4]


    fld     d [eax + 2*4*4]       ;a20
    fmul    d [edx]               ;a20*b00
    fld     d [eax + 1*4 + 2*4*4] ;a21      a20*b00
    fld     d [eax + 2*4 + 2*4*4] ;a22      a21      a20*b00
    fmul    d [edx + 2*4*4]       ;a22*b20  a21      a20*b00
    fxch    st(1)                 ;a21      a22*b20  a20*b00
    fmul    d [edx + 1*4*4]       ;a21*b10  a22*b20  a20*b00
    fxch    st(2)                 ;a20*b00  a22*b20  a21*b10
    faddp   st(1), st(0)          ;prawie20 a21*b10
    fld     d [eax + 2*4*4]       ;a20      prawie20 a21*b10
    fmul    d [edx + 1*4]         ;a20*b01  prawie20 a21*b10
    fxch    st(2)                 ;a21*b10  prawie20 a20*b01
    faddp   st(1), st(0)          ;temp20   a20*b01
    fld     d [eax + 1*4 + 2*4*4] ;a21      temp20   a20*b01
    fld     d [eax + 2*4 + 2*4*4] ;a22      a21      temp20  a20*b01
    fmul    d [edx + 2*4*4 + 1*4] ;a22*b21  a21      temp20  a20*b01
    fxch    st(1)                 ;a21      a22*b21  temp20  a20*b01
    fmul    d [edx + 1*4*4 + 1*4] ;a21*b11  a22*b21  temp20  a20*b01
    fxch    st(3)                 ;a20*b01  a22*b21  temp20  a21*b11
    faddp   st(1), st(0)          ;prawie21 temp20   a21*b11
    fld     d [eax + 2*4*4]       ;a20      prawie21 temp20  a21*b11
    fmul    d [edx + 2*4]         ;a20*b02  prawie21 temp20  a21*b11
    fxch    st(3)                 ;a21*b11  prawie21 temp20  a20*b02
    faddp   st(1), st(0)          ;temp21   temp20   a20*b02
    fld     d [eax + 1*4 + 2*4*4] ;a21      temp21   temp20   a20*b02
    fld     d [eax + 2*4 + 2*4*4] ;a22      a21      temp21   temp20  a20*b02
    fmul    d [edx + 2*4*4 + 2*4] ;a22*b22  a21      temp21   temp20  a20*b02
    fld     d [Value_0]           ;0.0      a22*b22  a21      temp21  temp20  a20*b02
    fxch    st(5)                 ;a20*b02  a22*b22  a21      temp21  temp20  0.0
    faddp   st(1), st(0)          ;prawie22 a21      temp21   temp20  0.0
    fxch    st(1)                 ;a21      prawie22 temp21   temp20  0.0
    fmul    d [edx + 1*4*4 + 2*4] ;a21*b12  prawie22 temp21   temp20  0.0
    faddp   st(1), st(0)          ;temp22   temp21   temp20   0.0
    fxch    st(2)                 ;temp20   temp21   temp22   0.0
    fstp    d [o temp_mtx + 2*4*4]       ;temp21   temp22   0.0
    fstp    d [o temp_mtx + 1*4 + 2*4*4] ;temp22   0.0
    fstp    d [o temp_mtx + 2*4 + 2*4*4] ;0.0
    fstp    d [o temp_mtx + 3*4 + 2*4*4]


    fld     d [eax + 3*4*4]       ;a30
    fmul    d [edx]               ;a30*b00
    fld     d [eax + 1*4 + 3*4*4] ;a31      a30*b00
    fld     d [eax + 2*4 + 3*4*4] ;a32      a31      a30*b00
    fmul    d [edx + 2*4*4]       ;a32*b20  a31      a30*b00
    fxch    st(1)                 ;a31      a32*b20  a30*b00
    fmul    d [edx + 1*4*4]       ;a31*b10  a32*b20  a30*b00
    fxch    st(2)                 ;a30*b00  a32*b20  a31*b10
    faddp   st(1), st(0)          ;prawie30 a31*b10
    fld     d [eax + 3*4*4]       ;a30      prawie30 a31*b10
    fmul    d [edx + 1*4]         ;a30*b01  prawie30 a31*b10
    fxch    st(2)                 ;a31*b10  prawie30 a30*b01
    faddp   st(1), st(0)          ;temp30   a30*b01
    fld     d [eax + 1*4 + 3*4*4] ;a31      temp30   a30*b01
    fld     d [eax + 2*4 + 3*4*4] ;a32      a31      temp30 a30*b01
    fmul    d [edx + 2*4*4 + 1*4] ;a32*b21  a31      temp30 a30*b01
    fxch    st(1)                 ;a31      a32*b21  temp30 a30*b01
    fmul    d [edx + 1*4*4 + 1*4] ;a31*b11  a32*b21  temp30 a30*b01
    fxch    st(3)                 ;a30*b01  a32*b21  temp30 a31*b11
    faddp   st(1), st(0)          ;prawie31 temp30  a31*b11
    fld     d [eax + 3*4*4]       ;a30      prawie31 temp30 a31*b11
    fmul    d [edx + 2*4]         ;a30*b02  prawie31 temp30 a31*b11
    fxch    st(3)                 ;a31*b11  prawie31 temp30 a30*b02
    faddp   st(1), st(0)          ;temp31  temp30  a30*b02
    fld     d [eax + 1*4 + 3*4*4] ;a31      temp31  temp30  a30*b02
    fld     d [eax + 2*4 + 3*4*4] ;a32      a31      temp31  temp30  a30*b02
    fmul    d [edx + 2*4*4 + 2*4] ;a32*b22  a31      temp31  temp30  a30*b02
    fld     d [Value_1]           ;1.0      a32*b22  a31      temp31 temp30 a30*b02
    fxch    st(5)                 ;a30*b02  a32*b22  a31      temp31 temp30 1.0
    faddp   st(1), st(0)          ;prawie32 a31      temp31  temp30 1.0
    fxch    st(1)                 ;a31      prawie32 temp31  temp30 1.0
    fmul    d [edx + 1*4*4 + 2*4] ;a31*b12  prawie32 temp31  temp30  1.0
    faddp   st(1), st(0)          ;temp32  temp31  temp30  1.0
    fxch    st(2)                 ;temp30  temp31  temp32  1.0
    fadd    d [edx + 3*4*4]       ;temp30   temp31  temp32  1.0
    fxch    st(1)                 ;temp31  temp30   temp32  1.0
    fadd    d [edx + 3*4*4 + 1*4] ;temp31   temp30   temp32  1.0
    fxch    st(2)                 ;temp32  temp30   temp31   1.0
    fadd    d [edx + 3*4*4 + 2*4] ;temp32   temp30   temp31   1.0
    fxch    st(1)                 ;temp30   temp32   temp31   1.0
    fstp    d [o temp_mtx + 3*4*4]       ;temp32   temp31   1.0
    fstp    d [o temp_mtx + 2*4 + 3*4*4] ;temp31   1.0
    fstp    d [o temp_mtx + 1*4 + 3*4*4] ;1.0
    fstp    d [o temp_mtx + 3*4 + 3*4*4]

    mov     edx, o temp_mtx
    mov     eax, ebx
    call    MatrixCopy_

    ret

;****************************************************************************
;*  void MatrixIdentity(matrix mtx)
;*
;*  Description: Function makes identity matrix
;*
;*  In  : EAX - pointer to matrix
;*
;*  Out : None
;****************************************************************************/
 MatrixIdentity_:
    push    edi
    push    ecx
    mov     edi, eax
    xor     eax, eax
    mov     ecx, 16
    rep     stosd
    mov     eax, [Value_1]
    mov     d [edi - 16*4], eax
    mov     d [edi - 16*4 + 5*4], eax
    mov     d [edi - 16*4 + 10*4], eax
    mov     d [edi - 16*4 + 15*4], eax
    pop     ecx
    pop     edi
    ret

;****************************************************************************
;*  MatrixRotateXYZ(matrix mtx, FLOAT anglex, FLOAT angley, FLOAT anglez)
;*
;*  Description: Function makes rotation matrix ( X, Y & Z axises )
;*
;*  In  : EAX     - matrix to make
;*        stack as below:
;*        anglex angley anglez
;*
;*  Out : None
;****************************************************************************/
 MatrixRotateXYZ_:
     ;                              st0       st1       st2       st3       st4       st5       st6
     fld    d [esp + 4]           ; angx
     fld    d [esp + 8]           ; angy      angx
     fld    d [esp + 12]          ; angz      angy      angx
     fsincos                      ; cosz      sinz      angy      angx
     fxch   st(2)                 ; angy      sinz      cosz      angx
     fsincos                      ; cosy      siny      sinz      cosz      angx
     fxch   st(4)                 ; angx      siny      sinz      cosz      cosy
     fsincos                      ; cosx      sinx      siny      sinz      cosz     cosy

     push   eax
     call   MatrixIdentity_
     pop    eax

     fstp   d [cosx]              ; sinx      siny      sinz      cosz      cosy
     fstp   d [sinx]              ; siny      sinz      cosz      cosy
     fstp   d [siny]              ; sinz      cosz      cosy
     fstp   d [sinz]              ; cosz      cosy
     fstp   d [cosz]              ; cosy
     fstp   d [cosy]              ;

     fld    d [cosy]              ; cosy
     fmul   d [cosz]              ; cy*cz
     fld    d [cosz]              ; cosz      cy*cz
     fmul   d [siny]              ; cz*sy     cy*cz
     fld    d [sinz]              ; sinz      cz*sy     cy*cz
     fld    d [cosx]              ; cosx      sinz      cz*sy     cy*cz
     fmul   st(0), st(1)          ; cx*sz     sinz      cz*sy     cy*cz
     fld    d [sinx]              ; sinx      cx*sz     sinz      cz*sy     cy*cz
     fmul   st(0), st(2)          ; sx*sz     cx*sz     sinz      cz*sy     cy*cz
     fxch   st(4)                 ; cy*cz     cx*sz     sinz      cz*sy     sx*sz
     fstp   d [eax]               ; cx*sz     sinz      cz*sy     sx*sz
     fld    d [sinx]              ; sinx      cx*sz     sinz      cz*sy     sx*sz
     fmul   st(0), st(3)          ; sx*cz*sy  cx*sz     sinz      cz*sy     sx*sz
     fld    d [cosx]              ; cosx      sx*cz*sy  cx*sz     sinz      cz*sy     sx*sz
     fld    d [Value_min_1]       ; -1.0      cosx      sx*cz*sy  cx*sz     sinz      cz*sy     sx*sz
     fmul   st(0), st(3)          ; -cx*sz    cosx      sx*cz*sy  cx*sz     sinz      cz*sy     sx*sz
     fxch   st(5)                 ; cz*sy     cosx      sx*cz*sy  cx*sz     sinz      -cx*sz    sx*sz
     fmulp  st(1), st(0)          ; cx*cz*sy  sx*cz*sy  cx*sz     sinz      -cx*sz    sx*sz
     fxch   st(1)                 ; sx*cz*sy  cx*cz*sy  cx*sz     sinz      -cx*sz    sx*sz
     faddp  st(4), st(0)          ; cx*cz*sy  cx*sz     sinz      mtx10     sx*sz
     faddp  st(4), st(0)          ; cx*sz     sinz      mtx10     mtx20
     fxch   st(1)                 ; sinz      cx*sz     mtx10     mtx20
     fmul   d [cosy]              ; cy*sz     cx*sz     mtx10     mtx20
     fxch   st(2)                 ; mtx10     cx*sz     cy*sz     mtx20
     fstp   d [eax + 1*4*4]       ; cx*sz     cy*sz     mtx20
     fxch   st(2)                 ; mtx20     cy*sz     cx*sz
     fstp   d [eax + 2*4*4]       ; cy*sz     cx*sz
     fstp   d [eax + 4]           ; cx*sz
     fmul   d [siny]              ; cx*sz*sy
     fld    d [cosx]              ; cosx      cx*sz*sy
     fld    d [cosy]              ; cosy      cosx      cx*sz*sy
     fmul   st(1), st(0)          ; cosy      mtx22     cx*sz*sy
     fld    d [sinx]              ; sinx      cosy      mtx22     cx*sz*sy
     fxch   st(2)                 ; mtx22     cosy      sinx      cx*sz*sy
     fstp   d [eax + 2*4*4 + 2*4] ; cosy      sinx      cx*sz*sy
     fmul   st(0), st(1)          ; mtx12     sinx      cx*sz*sy
     fld    d [siny]              ; siny      mtx12     sinx      cx*sz*sy
     fld    d [Value_min_1]       ; -1.0      siny      mtx12     sinx      cx*sz*sy
     fmul   st(3), st(0)          ; -1.0      siny      mtx12     -sinx     cx*sz*sy
     fxch   st(2)                 ; mtx12     siny      -1.0      -sinx     cx*sz*sy
     fstp   d [eax + 1*4*4 + 2*4] ; siny      -1.0      -sinx     cx*sz*sy
     fmulp  st(1), st(0)          ; mtx02     -sinx     cx*sz*sy
     fld    d [cosz]              ; cosz      mtx02     -sinx     cx*sz*sy
     fmul   st(2), st(0)          ; cosz      mtx02     -sx*cz    cx*sz*sy
     fxch   st(1)                 ; mtx02     cosz      -sx*cz    cx*sz*sy
     fstp   d [eax + 2*4]         ; cosz      -sx*cz    cx*sz*sy
     fmul   d [cosx]              ; cz*cx     -sx*cz    cx*sz*sy
     fxch   st(2)                 ; cx*sz*sy  -sx*cz    cz*cx
     faddp  st(1), st(0)          ; mtx21     cz*cx
     fld    d [sinx]              ; sinx      mtx21     cz*cx
     fmul   d [siny]              ; sy*sx     mtx21     cz*cx
     fxch   st(1)                 ; mtx21     sy*sx     cz*cx
     fstp   d [eax + 2*4*4 + 1*4] ; sy*sx     cz*cx
     fmul   d [sinz]              ; sy*sx*sz  cz*cz
     faddp  st(1), st(0)          ; mtx11
     fstp   d [eax + 1*4*4 + 1*4]

     ret    0ch

;****************************************************************************
;*  CalcObjectMatrix(world3d *w, UDWORD obj_num)
;*
;*  Description: Creates object matrix
;*
;*  In  : EAX     - pointer to world
;*        EDX     - object number
;*
;*  Out : None
;****************************************************************************/
 CalcObjectMatrix_:
     push   ebx
     imul   ebx, edx, object_size
     add    ebx, [eax.objects]

     mov    eax, ebx
     add    eax, obj_mtx
     push   d [ebx.obj_ang_z]
     push   d [ebx.obj_ang_y]
     push   d [ebx.obj_ang_x]
     call   MatrixRotateXYZ_

     fld    d [ebx.obj_pos_x]
     fadd   d [ebx.obj_mtx + 3*4*4]
     fld    d [ebx.obj_pos_y]
     fadd   d [ebx.obj_mtx + 3*4*4 + 4]
     fld    d [ebx.obj_pos_z]
     fadd   d [ebx.obj_mtx + 3*4*4 + 8]
     fxch   st(2)
     fstp   d [ebx.obj_mtx + 3*4*4]
     fstp   d [ebx.obj_mtx + 3*4*4 + 4]
     fstp   d [ebx.obj_mtx + 3*4*4 + 8]

     pop    ebx
     ret

;****************************************************************************
;*  CalcCameraMatrix(camera *c)
;*
;*  Description: Creates camera matrix
;*
;*  In  : EAX     - pointer to camera
;*
;*  Out : None
;****************************************************************************/
 CalcCameraMatrix_:
     push   ebx

     mov    ebx, eax

     mov    [u.vec_x], 3f800000h ;1.0
     mov    [u.vec_y], 0
     mov    [u.vec_z], 0

     mov    [v.vec_x], 0
     mov    [v.vec_y], 3f800000h ;1.0
     mov    [v.vec_z], 0

     mov    [n.vec_x], 0
     mov    [n.vec_y], 0
     mov    [n.vec_z], 3f800000h ;1.0

     fld    d [ebx.c_roll]
     fsincos
     fxch   st(1)
     fmul   d [Value_min_1]
     fxch   st(1)
     fstp   d [v.vec_y]
     fstp   d [v.vec_x]

     push   o n
     push   d [ebx.c_tgt_z]
     push   d [ebx.c_tgt_y]
     push   d [ebx.c_tgt_x]
     push   d [ebx.c_pos_z]
     push   d [ebx.c_pos_y]
     push   d [ebx.c_pos_x]
     call   VectorCreate_

     mov    eax, o n
     call   VectorNormalize_

     mov    eax, [n.vec_x]
     mov    [ebx.c_dir_x], eax
     mov    eax, [n.vec_y]
     mov    [ebx.c_dir_y], eax
     mov    eax, [n.vec_z]
     mov    [ebx.c_dir_z], eax

     push   d [n.vec_z]
     push   d [n.vec_y]
     push   d [n.vec_x]
     push   d [v.vec_z]
     push   d [v.vec_y]
     push   d [v.vec_x]
     call   VectorDot_

     ;  v.x -= (temp * n.x);  v.y -= (temp * n.y);  v.z -= (temp * n.z);
     ;                    st0  st1  st2  st3  st4  st5
                        ; temp
     fld    d [n.vec_x] ; nx   temp
     fld    d [n.vec_y] ; ny   nx   temp
     fld    d [n.vec_z] ; nz   ny   nx   temp
     fmul   st(0), st(3); okz  ny   nx   temp
     fxch   st(1)       ; ny   okz  nx   temp
     fmul   st(0), st(3); oky  okz  nx   temp
     fxch   st(2)       ; nx   okz  oky  temp
     fmulp  st(3), st(0); okz  oky  okx
     fld    d [v.vec_x] ; vx   okz  oky  okx
     fld    d [v.vec_y] ; vy   vx   okz  oky  okx
     fld    d [v.vec_z] ; vz   vy   vx   okz  oky  okx
     fsubrp st(3), st(0); vy   vx   ookz oky  okx
     fsubrp st(3), st(0); vx   ookz ooky okx
     fsubrp st(3), st(0); ookz ooky ookx
     fstp   d [v.vec_z]
     fstp   d [v.vec_y]
     fstp   d [v.vec_x]

     mov    eax, o v
     call   VectorNormalize_

     push   o u
     push   d [n.vec_z]
     push   d [n.vec_y]
     push   d [n.vec_x]
     push   d [v.vec_z]
     push   d [v.vec_y]
     push   d [v.vec_x]
     call   VectorCross_

     mov    eax, [u.vec_x]
     mov    [ebx.c_mtx], eax
     mov    eax, [u.vec_y]
     mov    [ebx.c_mtx + 1*4*4], eax
     mov    eax, [u.vec_z]
     mov    [ebx.c_mtx + 2*4*4], eax

     mov    eax, [v.vec_x]
     mov    [ebx.c_mtx +1*4], eax
     mov    eax, [v.vec_y]
     mov    [ebx.c_mtx + 1*4*4 +1*4], eax
     mov    eax, [v.vec_z]
     mov    [ebx.c_mtx + 2*4*4 +1*4], eax

     mov    eax, [n.vec_x]
     mov    [ebx.c_mtx +2*4], eax
     mov    eax, [n.vec_y]
     mov    [ebx.c_mtx + 1*4*4 +2*4], eax
     mov    eax, [n.vec_z]
     mov    [ebx.c_mtx + 2*4*4 +2*4], eax

     fld    d [ebx.c_pos_x]
     fmul   d [u.vec_x]
     fld    d [ebx.c_pos_y]
     fmul   d [u.vec_y]
     fld    d [ebx.c_pos_z]
     fmul   d [u.vec_z]
     fxch   st(2)
     faddp  st(1), st(0)
     faddp  st(1), st(0)
     fmul   d [Value_min_1]
     fstp   d [ebx.c_mtx + 3*4*4 + 0*4]

     fld    d [ebx.c_pos_x]
     fmul   d [v.vec_x]
     fld    d [ebx.c_pos_y]
     fmul   d [v.vec_y]
     fld    d [ebx.c_pos_z]
     fmul   d [v.vec_z]
     fxch   st(2)
     faddp  st(1), st(0)
     faddp  st(1), st(0)
     fmul   d [Value_min_1]
     fstp   d [ebx.c_mtx + 3*4*4 + 1*4]

     fld    d [ebx.c_pos_x]
     fmul   d [n.vec_x]
     fld    d [ebx.c_pos_y]
     fmul   d [n.vec_y]
     fld    d [ebx.c_pos_z]
     fmul   d [n.vec_z]
     fxch   st(2)
     faddp  st(1), st(0)
     faddp  st(1), st(0)
     fmul   d [Value_min_1]
     fstp   d [ebx.c_mtx + 3*4*4 + 2*4]

     pop    ebx
     ret


;****************************************************************************
;*  TransformPoints(matrix mtx, vector *vsrc, vector *vdst, UDWORD count)
;*
;*  Description: Transforms points by matrix
;*
;*  In  : EAX     - pointer to matrix
;*        EDX     - pointer to src points
;*        EBX     - pointer to dst points
;*        ECX     - number of points
;*
;*  Out : None
;****************************************************************************/
 TransformPoints_:
 tp_petla:
     fld    d [edx.vec_x]
     fmul   d [eax + 0*4*4 + 0*4]
     fld    d [edx.vec_y]
     fmul   d [eax + 1*4*4 + 0*4]
     fld    d [edx.vec_z]
     fmul   d [eax + 2*4*4 + 0*4]
     fxch   st(2)
     fadd   d [eax + 3*4*4 + 0*4]
     fxch   st(1)
     faddp  st(2), st(0)
     faddp  st(1), st(0)
     fstp   d [ebx.vec_x]

     fld    d [edx.vec_x]
     fmul   d [eax + 0*4*4 + 1*4]
     fld    d [edx.vec_y]
     fmul   d [eax + 1*4*4 + 1*4]
     fld    d [edx.vec_z]
     fmul   d [eax + 2*4*4 + 1*4]
     fxch   st(2)
     fadd   d [eax + 3*4*4 + 1*4]
     fxch   st(1)
     faddp  st(2), st(0)
     faddp  st(1), st(0)
     fstp   d [ebx.vec_y]

     fld    d [edx.vec_x]
     fmul   d [eax + 0*4*4 + 2*4]
     fld    d [edx.vec_y]
     fmul   d [eax + 1*4*4 + 2*4]
     fld    d [edx.vec_z]
     fmul   d [eax + 2*4*4 + 2*4]
     fxch   st(2)
     fadd   d [eax + 3*4*4 + 2*4]
     fxch   st(1)
     faddp  st(2), st(0)
     faddp  st(1), st(0)
     fstp   d [ebx.vec_z]

     add    edx, vec_size
     add    ebx, vec_size
     dec    ecx
     jnz    tp_petla
     ret

;****************************************************************************
;*  SetObjectSkin(world3d *w, UDWORD obj_num, UDWORD *text)
;*
;*  Description: Sets object texture
;*
;*  In  : EAX     - pointer to world
;*        EDX     - object number
;*        EBX     - pointer to texture to set
;*
;*  Out : None
;****************************************************************************/
 SetObjectSkin_:
     push   ebp
     push   ecx

     imul   ebp, edx, object_size
     add    ebp, [eax.objects]

     movzx  ecx, [ebp.obj_num_faces]
     mov    eax, [ebp.obj_faces]
 sos_petla:
     mov    [eax.t_texture], ebx
     add    eax, triangle_size
     dec    ecx
     jnz    sos_petla

     pop    ecx
     pop    ebp
     ret

;****************************************************************************
;*  SetupWorldData(world3d *w, void *data)
;*
;*  Description: "Loads" world to memory
;*
;*  In  : EAX     - pointer to world
;*        EDX     - pointer to free mem (at least _World_size)
;*
;*  Out : None
;****************************************************************************/
 SetupWorldData_:
     pushad

     mov    ebx, eax

     add    eax, 2 + c_mtx
     call   MatrixIdentity_

     mov    [ebx.objects], edx

     mov    cx, [ebx]
     mov    [ilosc_obj], cx

     mov    esi, ebx
     mov    edi, edx
     add    esi, world3d_size
     xor    ecx, ecx
 swd_petla_obiektow:
     ; EDI zawiera wskaznik na wolna pamiec
     ; ESI zawiera wskaznik na czytane dane

     movsd  ;\
     movsd  ; object.position
     movsd  ;/

     xor    eax, eax
     stosd  ;\
     stosd  ; object.angle(x,y,z)
     stosd  ;/

     movsd  ; object.num_verts i object.num_faces

     mov    eax, edi
     add    eax, 6*4
     call   MatrixIdentity_

     add    edi, (6 + 16)*4 ; nastepny objekt

     inc    ecx
     cmp    cx, [ilosc_obj]
     jnz    swd_petla_obiektow

     mov    ebx, [ebx.objects]
     xor    ecx, ecx
 swd_petla_punktow:
     ; EDI zawiera wskaznik na wolna pamiec
     ; EBX zawiera wskaznik na aktualnie przetwarzany obiekt
     ; ESI zawiera wskaznik na czytane dane
     mov    [ebx.obj_verts], esi
     movzx  eax, [ebx.obj_num_verts]
     shl    eax, 3   ;\
     add    esi, eax ; obj_num_verts * 12
     shr    eax, 1   ;
     add    esi, eax ;/

     ; zapisujemy teraz wspolrzedne tekstury
     mov    [ebx.obj_vertex2d], edi
     xor    ebp, ebp
     movzx  ebp, [ebx.obj_num_verts]
 swd_petla_uv:
     mov    eax, [esi]
     mov    [edi.vert_u], eax
     mov    eax, [esi+4]
     mov    [edi.vert_v], eax
     add    esi, 2*4
     add    edi, vert2d_size
     dec    ebp
     jnz    swd_petla_uv

     ; zapisujemy numery scian
     mov    [ebx.obj_faces], edi
     movzx  ebp, [ebx.obj_num_faces]
 swd_petla_scian:
     mov    eax, [esi]
     mov    d [edi.t_p1], eax ; zapisujemy p1 i p2
     mov    ax, [esi + 4]
     mov    [edi.t_p3], ax
     add    esi, 3*2
     add    edi, triangle_size
     dec    ebp
     jnz    swd_petla_scian

     mov    [ebx.obj_verts_rot], edi
     movzx  eax, [ebx.obj_num_verts]
     shl    eax, 3   ;\
     add    edi, eax ; obj_num_verts*12
     shr    eax, 1   ;
     add    edi, eax ;/

     mov    [ebx.obj_norm], edi
     movzx  eax, [ebx.obj_num_verts]
     shl    eax, 3   ;\
     add    edi, eax ; obj_num_verts*12
     shr    eax, 1   ;
     add    edi, eax ;/

     mov    [ebx.obj_norm_rot], edi
     movzx  eax, [ebx.obj_num_verts]
     shl    eax, 3   ;\
     add    edi, eax ; obj_num_verts*12
     shr    eax, 1   ;
     add    edi, eax ;/

     add    ebx, object_size
     inc    ecx
     cmp    cx, [ilosc_obj]
     jnz    swd_petla_punktow

     popad
     ret


 ;===========================================================================
 sqrt_:
     fld    qword ptr [esp+4]
     fsqrt
     ret    8

MatrixNormalize_:
                push    ebx
                push    ecx
                push    esi
                push    edi
                push    ebp
                mov     ebp,esp
                sub     esp,00000054H
                mov     dword ptr [ebp-10H],eax
                mov     dword ptr [ebp-14H],edx
                lea     eax,[ebp-54H]
                call    near ptr MatrixIdentity_
                mov     dword ptr [ebp-4H],00000000H
L1:             cmp     dword ptr [ebp-4H],00000003H
                jb      short L3
                jmp     near ptr L10
L2:             mov     eax,dword ptr [ebp-4H]
                inc     dword ptr [ebp-4H]
                jmp     short L1
L3:             mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                mov     edx,dword ptr [ebp-10H]
                add     edx,eax
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                add     eax,dword ptr [ebp-10H]
                fld     dword ptr [edx+10H]
                fmul    dword ptr [eax+10H]
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                mov     edx,dword ptr [ebp-10H]
                add     edx,eax
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                add     eax,dword ptr [ebp-10H]
                fld     dword ptr [edx]
                fmul    dword ptr [eax]
                faddp   st(1),st
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                mov     edx,dword ptr [ebp-10H]
                add     edx,eax
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                add     eax,dword ptr [ebp-10H]
                fld     dword ptr [edx+20H]
                fmul    dword ptr [eax+20H]
                faddp   st(1),st
                sub     esp,00000008H
                fstp    qword ptr [esp]
                call    sqrt_
                fstp    dword ptr [ebp-8H]
                test    dword ptr [ebp-8H],7fffffffH
                je      short L4
                fld     dword ptr [ebp-8H]
                fld1
                fdivrp  st(1),st
                fstp    dword ptr [ebp-8H]
                jmp     short L5
L4:             mov     dword ptr [ebp-8H],3f800000H
L5:             mov     dword ptr [ebp-0cH],00000000H
L6:             cmp     dword ptr [ebp-0cH],00000003H
                jb      short L8
                jmp     short L9
L7:             mov     eax,dword ptr [ebp-0cH]
                inc     dword ptr [ebp-0cH]
                jmp     short L6
L8:             mov     eax,dword ptr [ebp-0cH]
                shl     eax,04H
                mov     edx,dword ptr [ebp-10H]
                add     edx,eax
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                add     eax,edx
                fld     dword ptr [eax]
                fmul    dword ptr [ebp-8H]
                mov     edx,dword ptr [ebp-0cH]
                shl     edx,04H
                mov     eax,dword ptr [ebp-4H]
                shl     eax,02H
                add     eax,edx
                fstp    dword ptr [eax+ebp-54H]
                jmp     short L7
L9:             jmp     near ptr L2
L10:            lea     edx,[ebp-54H]
                mov     eax,dword ptr [ebp-14H]
                call    near ptr MatrixCopy_
                mov     esp,ebp
                pop     ebp
                pop     edi
                pop     esi
                pop     ecx
                pop     ebx
                ret
                mov     eax,eax
CalcObjectNormals_:
                push    ebx
                push    ecx
                push    esi
                push    edi
                push    ebp
                mov     ebp,esp
                sub     esp,00000054H
                mov     dword ptr [ebp-20H],eax
                mov     dword ptr [ebp-24H],edx
                imul    edx,dword ptr [ebp-24H],74H
                mov     eax,dword ptr [ebp-20H]
                mov     eax,dword ptr [eax+6aH]
                add     eax,edx
                mov     dword ptr [ebp-1cH],eax
                mov     dword ptr [ebp-10H],00000000H
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+30H]
                mov     dword ptr [ebp-18H],eax
L11:            mov     eax,dword ptr [ebp-1cH]
                mov     ax,word ptr [eax+1aH]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-10H]
                jg      short L13
                jmp     near ptr L15
L12:            mov     eax,dword ptr [ebp-10H]
                inc     dword ptr [ebp-10H]
                mov     eax,dword ptr [ebp-18H]
                add     dword ptr [ebp-18H],00000017H
                jmp     short L11
L13:            mov     eax,dword ptr [ebp-18H]
                xor     edx,edx
                mov     dx,word ptr [eax+12H]
                imul    edx,0cH
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+1cH]
                add     edx,eax
                mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                imul    eax,0cH
                mov     ebx,dword ptr [ebp-1cH]
                mov     ebx,dword ptr [ebx+1cH]
                add     eax,ebx
                fld     dword ptr [edx]
                fsub    dword ptr [eax]
                fstp    dword ptr [ebp-30H]
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+12H]
                imul    edx,eax,0cH
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+1cH]
                add     edx,eax
                mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                imul    ebx,eax,0cH
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+1cH]
                add     eax,ebx
                fld     dword ptr [edx+4H]
                fsub    dword ptr [eax+4H]
                fstp    dword ptr [ebp-2cH]
                mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+12H]
                and     eax,0000ffffH
                imul    eax,0cH
                mov     edx,dword ptr [ebp-1cH]
                mov     edx,dword ptr [edx+1cH]
                add     edx,eax
                mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                imul    ebx,eax,0cH
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+1cH]
                add     eax,ebx
                fld     dword ptr [edx+8H]
                fsub    dword ptr [eax+8H]
                fstp    dword ptr [ebp-28H]
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+14H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-1cH]
                mov     edx,dword ptr [edx+1cH]
                lea     ebx,[edx+eax]
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+10H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-1cH]
                mov     edx,dword ptr [edx+1cH]
                add     eax,edx
                fld     dword ptr [ebx]
                fsub    dword ptr [eax]
                fstp    dword ptr [ebp-3cH]
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+14H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-1cH]
                mov     edx,dword ptr [edx+1cH]
                lea     ebx,[edx+eax]
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+10H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-1cH]
                mov     edx,dword ptr [edx+1cH]
                add     eax,edx
                fld     dword ptr [ebx+4H]
                fsub    dword ptr [eax+4H]
                fstp    dword ptr [ebp-38H]
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+14H]
                imul    eax,0cH
                mov     ebx,dword ptr [ebp-1cH]
                mov     ebx,dword ptr [ebx+1cH]
                add     ebx,eax
                mov     edx,dword ptr [ebp-18H]
                xor     eax,eax
                mov     ax,word ptr [edx+10H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-1cH]
                mov     edx,dword ptr [edx+1cH]
                add     eax,edx
                fld     dword ptr [ebx+8H]
                fsub    dword ptr [eax+8H]
                fstp    dword ptr [ebp-34H]
                lea     eax,[ebp-48H]
                push    eax
                lea     edi,[ebp-54H]
                lea     esi,[ebp-3cH]
                movsd
                movsd
                movsd
                push    dword ptr [ebp-4cH]
                push    dword ptr [ebp-50H]
                push    dword ptr [ebp-54H]
                lea     edi,[ebp-54H]
                lea     esi,[ebp-30H]
                movsd
                movsd
                movsd
                push    dword ptr [ebp-4cH]
                push    dword ptr [ebp-50H]
                push    dword ptr [ebp-54H]
                call    near ptr VectorCross_
                lea     edi,[ebp-54H]
                lea     esi,[ebp-48H]
                movsd
                movsd
                movsd
                push    dword ptr [ebp-4cH]
                push    dword ptr [ebp-50H]
                push    dword ptr [ebp-54H]
                call    near ptr VectorLength_
                fstp    dword ptr [ebp-4H]
                test    dword ptr [ebp-4H],7fffffffH
                jne     short L14
                mov     dword ptr [ebp-4H],33d6bf95H
L14:            fld     dword ptr [ebp-48H]
                fdiv    dword ptr [ebp-4H]
                fstp    dword ptr [ebp-48H]
                fld     dword ptr [ebp-44H]
                fdiv    dword ptr [ebp-4H]
                fstp    dword ptr [ebp-44H]
                fld     dword ptr [ebp-40H]
                fdiv    dword ptr [ebp-4H]
                fstp    dword ptr [ebp-40H]
                mov     edi,dword ptr [ebp-18H]
                lea     edi,[edi+4H]
                lea     esi,[ebp-48H]
                movsd
                movsd
                movsd
                jmp     near ptr L12
L15:            mov     dword ptr [ebp-10H],00000000H
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+24H]
                mov     dword ptr [ebp-14H],eax
L16:            mov     eax,dword ptr [ebp-1cH]
                mov     ax,word ptr [eax+18H]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-10H]
                jg      short L18
                jmp     near ptr L28
L17:            mov     eax,dword ptr [ebp-10H]
                inc     dword ptr [ebp-10H]
                mov     eax,dword ptr [ebp-14H]
                add     dword ptr [ebp-14H],0000000cH
                jmp     short L16
L18:            mov     dword ptr [ebp-8H],00000000H
                mov     dword ptr [ebp-40H],00000000H
                mov     eax,dword ptr [ebp-40H]
                mov     dword ptr [ebp-44H],eax
                mov     eax,dword ptr [ebp-44H]
                mov     dword ptr [ebp-48H],eax
                mov     eax,dword ptr [ebp-1cH]
                mov     eax,dword ptr [eax+30H]
                mov     dword ptr [ebp-18H],eax
                mov     dword ptr [ebp-0cH],00000000H
L19:            mov     eax,dword ptr [ebp-1cH]
                mov     ax,word ptr [eax+1aH]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-0cH]
                jg      short L21
                jmp     near ptr L25
L20:            mov     eax,dword ptr [ebp-0cH]
                inc     dword ptr [ebp-0cH]
                mov     eax,dword ptr [ebp-18H]
                add     dword ptr [ebp-18H],00000017H
                jmp     short L19
L21:            mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-10H]
                jne     short L22
                mov     eax,dword ptr [ebp-8H]
                inc     dword ptr [ebp-8H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-48H]
                fadd    dword ptr [eax+4H]
                fstp    dword ptr [ebp-48H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-44H]
                fadd    dword ptr [eax+8H]
                fstp    dword ptr [ebp-44H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-40H]
                fadd    dword ptr [eax+0cH]
                fstp    dword ptr [ebp-40H]
L22:            mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+12H]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-10H]
                jne     short L23
                mov     eax,dword ptr [ebp-8H]
                inc     dword ptr [ebp-8H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-48H]
                fadd    dword ptr [eax+4H]
                fstp    dword ptr [ebp-48H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-44H]
                fadd    dword ptr [eax+8H]
                fstp    dword ptr [ebp-44H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-40H]
                fadd    dword ptr [eax+0cH]
                fstp    dword ptr [ebp-40H]
L23:            mov     eax,dword ptr [ebp-18H]
                mov     ax,word ptr [eax+14H]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-10H]
                jne     short L24
                mov     eax,dword ptr [ebp-8H]
                inc     dword ptr [ebp-8H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-48H]
                fadd    dword ptr [eax+4H]
                fstp    dword ptr [ebp-48H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-44H]
                fadd    dword ptr [eax+8H]
                fstp    dword ptr [ebp-44H]
                mov     eax,dword ptr [ebp-18H]
                fld     dword ptr [ebp-40H]
                fadd    dword ptr [eax+0cH]
                fstp    dword ptr [ebp-40H]
L24:            jmp     near ptr L20
L25:            cmp     dword ptr [ebp-8H],00000000H
                je      short L26
                fild    dword ptr [ebp-8H]
                fdivr   dword ptr [ebp-48H]
                fstp    dword ptr [ebp-48H]
                fild    dword ptr [ebp-8H]
                fdivr   dword ptr [ebp-44H]
                fstp    dword ptr [ebp-44H]
                fild    dword ptr [ebp-8H]
                fdivr   dword ptr [ebp-40H]
                fstp    dword ptr [ebp-40H]
                jmp     short L27
L26:            mov     dword ptr [ebp-40H],00000000H
                mov     eax,dword ptr [ebp-40H]
                mov     dword ptr [ebp-44H],eax
                mov     eax,dword ptr [ebp-44H]
                mov     dword ptr [ebp-48H],eax
L27:            mov     edi,dword ptr [ebp-14H]
                lea     esi,[ebp-48H]
                movsd
                movsd
                movsd
                jmp     near ptr L17
L28:            mov     esp,ebp
                pop     ebp
                pop     edi
                pop     esi
                pop     ecx
                pop     ebx
                ret
SetObjectType_: push    ecx
                push    esi
                push    edi
                push    ebp
                mov     ebp,esp
                sub     esp,00000018H
                mov     dword ptr [ebp-18H],eax
                mov     dword ptr [ebp-14H],edx
                mov     byte ptr [ebp-4H],bl
                imul    edx,dword ptr [ebp-14H],74H
                mov     eax,dword ptr [ebp-18H]
                mov     eax,dword ptr [eax+6aH]
                add     eax,edx
                mov     dword ptr [ebp-0cH],eax
                mov     dword ptr [ebp-10H],00000000H
                mov     eax,dword ptr [ebp-0cH]
                mov     eax,dword ptr [eax+30H]
                mov     dword ptr [ebp-8H],eax
L29:            mov     eax,dword ptr [ebp-0cH]
                mov     ax,word ptr [eax+1aH]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-10H]
                ja      short L31
                jmp     short L32
L30:            mov     eax,dword ptr [ebp-10H]
                inc     dword ptr [ebp-10H]
                mov     eax,dword ptr [ebp-8H]
                add     dword ptr [ebp-8H],00000017H
                jmp     short L29
L31:            mov     al,byte ptr [ebp-4H]
                mov     edx,dword ptr [ebp-8H]
                mov     byte ptr [edx+16H],al
                jmp     short L30
L32:            mov     esp,ebp
                pop     ebp
                pop     edi
                pop     esi
                pop     ecx
                ret

RenderWorld_:   push    ebx
                push    ecx
                push    edx
                push    esi
                push    edi
                push    ebp
                mov     ebp,esp
                sub     esp,0000012cH
                mov     dword ptr [ebp-2cH],eax
                mov     eax,dword ptr [ebp-2cH]
                mov     eax,dword ptr [eax+6aH]
                mov     dword ptr [ebp-28H],eax
                mov     eax,dword ptr [ebp-2cH]
                add     eax,00000002H
                mov     dword ptr [ebp-8H],eax
                inc     word ptr _m3d_ZFrame
                mov     eax,dword ptr [ebp-8H]
                call    near ptr CalcCameraMatrix_
                mov     dword ptr [ebp-24H],00000000H
L33:            mov     eax,dword ptr [ebp-2cH]
                mov     ax,word ptr [eax]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-24H]
                jg      short L35
                jmp     near ptr L66
L34:            mov     eax,dword ptr [ebp-24H]
                inc     dword ptr [ebp-24H]
                mov     eax,dword ptr [ebp-28H]
                add     dword ptr [ebp-28H],00000074H
                jmp     short L33
L35:            mov     edx,dword ptr [ebp-24H]
                mov     eax,dword ptr [ebp-2cH]
                call    near ptr CalcObjectMatrix_
                mov     ebx,dword ptr [ebp-28H]
                add     ebx,00000034H
                mov     edx,dword ptr [ebp-8H]
                add     edx,00000028H
                mov     eax,dword ptr [ebp-28H]
                add     eax,00000034H
                call    near ptr MatrixMultiply_
                mov     ecx,dword ptr [ebp-28H]
                mov     cx,word ptr [ecx+18H]
                and     ecx,0000ffffH
                mov     ebx,dword ptr [ebp-28H]
                mov     ebx,dword ptr [ebx+20H]
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+1cH]
                mov     eax,dword ptr [ebp-28H]
                add     eax,00000034H
                call    near ptr TransformPoints_
                mov     edx,dword ptr [ebp-28H]
                add     edx,00000034H
                mov     eax,dword ptr [ebp-28H]
                add     eax,00000034H
                call    near ptr MatrixNormalize_
                mov     ecx,dword ptr [ebp-28H]
                mov     cx,word ptr [ecx+18H]
                and     ecx,0000ffffH
                mov     ebx,dword ptr [ebp-28H]
                mov     ebx,dword ptr [ebx+28H]
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+24H]
                mov     eax,dword ptr [ebp-28H]
                add     eax,00000034H
                call    near ptr TransformPoints_
                mov     ebx,dword ptr [ebp-28H]
                mov     bx,word ptr [ebx+18H]
                and     ebx,0000ffffH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+2cH]
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                call    near ptr MakePerspective_
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+30H]
                mov     dword ptr [ebp-30H],eax
                mov     dword ptr [ebp-34H],00000000H
L36:            mov     eax,dword ptr [ebp-28H]
                mov     ax,word ptr [eax+1aH]
                and     eax,0000ffffH
                cmp     eax,dword ptr [ebp-34H]
                jg      short L38
                jmp     near ptr L65
L37:            mov     eax,dword ptr [ebp-34H]
                inc     dword ptr [ebp-34H]
                mov     eax,dword ptr [ebp-30H]
                add     dword ptr [ebp-30H],00000017H
                jmp     short L36
L38:            mov     byte ptr [ebp-4H],00H
                mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                imul    edx,eax,0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [eax+8H]
                fcomp   dword ptr _NEAR_CLIP
                fstsw   ax
                sahf
                jb      short L39
                mov     al,byte ptr [ebp-4H]
                inc     byte ptr [ebp-4H]
L39:            mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+12H]
                and     eax,0000ffffH
                imul    edx,eax,0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [eax+8H]
                fcomp   dword ptr _NEAR_CLIP
                fstsw   ax
                sahf
                jb      short L40
                mov     al,byte ptr [ebp-4H]
                inc     byte ptr [ebp-4H]
L40:            mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+14H]
                and     eax,0000ffffH
                imul    edx,eax,0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [eax+8H]
                fcomp   dword ptr _NEAR_CLIP
                fstsw   ax
                sahf
                jb      short L41
                mov     al,byte ptr [ebp-4H]
                inc     byte ptr [ebp-4H]
L41:            cmp     byte ptr [ebp-4H],00H
                jbe     short L42
                cmp     byte ptr [ebp-4H],03H
                jb      short L43
L42:            jmp     near ptr L62
L43:            mov     dword ptr [ebp-0cH],00000000H
                mov     dword ptr [ebp-20H],00000000H
L44:            cmp     dword ptr [ebp-20H],00000003H
                jl      short L46
                jmp     near ptr L61
L45:            mov     eax,dword ptr [ebp-20H]
                inc     dword ptr [ebp-20H]
                jmp     short L44
L46:            mov     eax,dword ptr [ebp-20H]
                inc     eax
                mov     dword ptr [ebp-1cH],eax
                cmp     dword ptr [ebp-1cH],00000003H
                jne     short L47
                mov     dword ptr [ebp-1cH],00000000H
L47:            cmp     dword ptr [ebp-20H],00000001H
                jb      short L48
                cmp     dword ptr [ebp-20H],00000001H
                jbe     short L49
                cmp     dword ptr [ebp-20H],00000002H
                je      short L50
                jmp     short L51
L48:            cmp     dword ptr [ebp-20H],00000000H
                jne     short L51
                xor     eax,eax
                mov     edx,dword ptr [ebp-30H]
                mov     ax,word ptr [edx+10H]
                mov     dword ptr [ebp-14H],eax
                jmp     short L51
L49:            xor     eax,eax
                mov     edx,dword ptr [ebp-30H]
                mov     ax,word ptr [edx+12H]
                mov     dword ptr [ebp-14H],eax
                jmp     short L51
L50:            xor     eax,eax
                mov     edx,dword ptr [ebp-30H]
                mov     ax,word ptr [edx+14H]
                mov     dword ptr [ebp-14H],eax
L51:            cmp     dword ptr [ebp-1cH],00000001H
                jb      short L52
                cmp     dword ptr [ebp-1cH],00000001H
                jbe     short L53
                cmp     dword ptr [ebp-1cH],00000002H
                je      short L54
                jmp     short L55
L52:            cmp     dword ptr [ebp-1cH],00000000H
                jne     short L55
                xor     eax,eax
                mov     edx,dword ptr [ebp-30H]
                mov     ax,word ptr [edx+10H]
                mov     dword ptr [ebp-10H],eax
                jmp     short L55
L53:            xor     eax,eax
                mov     edx,dword ptr [ebp-30H]
                mov     ax,word ptr [edx+12H]
                mov     dword ptr [ebp-10H],eax
                jmp     short L55
L54:            xor     eax,eax
                mov     edx,dword ptr [ebp-30H]
                mov     ax,word ptr [edx+14H]
                mov     dword ptr [ebp-10H],eax
L55:            imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [eax+8H]
                fcomp   dword ptr _NEAR_CLIP
                fstsw   ax
                sahf
                jbe     near ptr L57
                imul    eax,dword ptr [ebp-14H],0cH
                mov     esi,dword ptr [ebp-28H]
                mov     esi,dword ptr [esi+20H]
                add     esi,eax
                imul    edi,dword ptr [ebp-0cH],0cH
                lea     edi,[edi+ebp-64H]
                movsd
                movsd
                movsd
                imul    esi,dword ptr [ebp-14H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     esi,eax
                imul    edi,dword ptr [ebp-0cH],1cH
                mov     ecx,00000007H
                lea     edi,[edi+ebp-128H]
                repe    movsd
                mov     eax,dword ptr [ebp-30H]
                cmp     byte ptr [eax+16H],02H
                jne     short L56
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                add     eax,edx
                fld     dword ptr [eax]
                fmul    dword ptr L67
                fstp    dword ptr [ebp-12cH]
                imul    eax,dword ptr [ebp-0cH],1cH
                fld     dword ptr [ebp-12cH]
                fadd    dword ptr L67
                fstp    dword ptr [eax+ebp-11cH]
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                add     eax,edx
                fld     dword ptr [eax+4H]
                fmul    dword ptr L67
                fstp    dword ptr [ebp-12cH]
                imul    eax,dword ptr [ebp-0cH],1cH
                fld     dword ptr [ebp-12cH]
                fadd    dword ptr L67
                fstp    dword ptr [eax+ebp-118H]
L56:            mov     eax,dword ptr [ebp-0cH]
                inc     dword ptr [ebp-0cH]
L57:            imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [eax+8H]
                fsub    dword ptr _NEAR_CLIP
                imul    edx,dword ptr [ebp-10H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [eax+8H]
                fsub    dword ptr _NEAR_CLIP
                fmulp   st(1),st
                fldz
                fcompp  st(1)
                fstsw   ax
                sahf
                jbe     near ptr L60
                imul    edx,dword ptr [ebp-10H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     edx,eax
                imul    ebx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,ebx
                fld     dword ptr [edx+8H]
                fsub    dword ptr [eax+8H]
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr _NEAR_CLIP
                fsub    dword ptr [eax+8H]
                fdivrp  st(1),st
                fstp    dword ptr [ebp-18H]
                imul    edx,dword ptr [ebp-10H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                lea     ebx,[eax+edx]
                imul    eax,dword ptr [ebp-14H],0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+20H]
                add     eax,edx
                fld     dword ptr [ebx]
                fsub    dword ptr [eax]
                fmul    dword ptr [ebp-18H]
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fadd    dword ptr [eax]
                imul    eax,dword ptr [ebp-0cH],0cH
                fstp    dword ptr [eax+ebp-64H]
                imul    ebx,dword ptr [ebp-10H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     ebx,eax
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+20H]
                add     eax,edx
                fld     dword ptr [ebx+4H]
                fsub    dword ptr [eax+4H]
                fmul    dword ptr [ebp-18H]
                imul    eax,dword ptr [ebp-14H],0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+20H]
                add     eax,edx
                fadd    dword ptr [eax+4H]
                imul    eax,dword ptr [ebp-0cH],0cH
                fstp    dword ptr [eax+ebp-60H]
                imul    eax,dword ptr [ebp-0cH],0cH
                fld     dword ptr _NEAR_CLIP
                fstp    dword ptr [eax+ebp-5cH]
                mov     eax,dword ptr [ebp-30H]
                cmp     byte ptr [eax+16H],01H
                jne     short L58
                imul    edx,dword ptr [ebp-10H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                lea     ebx,[eax+edx]
                imul    edx,dword ptr [ebp-14H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     eax,edx
                fld     dword ptr [ebx+0cH]
                fsub    dword ptr [eax+0cH]
                fmul    dword ptr [ebp-18H]
                imul    edx,dword ptr [ebp-14H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     eax,edx
                fadd    dword ptr [eax+0cH]
                imul    eax,dword ptr [ebp-0cH],1cH
                fstp    dword ptr [eax+ebp-11cH]
                imul    edx,dword ptr [ebp-10H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                lea     ebx,[eax+edx]
                imul    edx,dword ptr [ebp-14H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     eax,edx
                fld     dword ptr [ebx+10H]
                fsub    dword ptr [eax+10H]
                fmul    dword ptr [ebp-18H]
                imul    edx,dword ptr [ebp-14H],1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     eax,edx
                fadd    dword ptr [eax+10H]
                imul    eax,dword ptr [ebp-0cH],1cH
                fstp    dword ptr [eax+ebp-118H]
                jmp     near ptr L59
L58:            imul    edx,dword ptr [ebp-10H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                lea     ebx,[eax+edx]
                imul    eax,dword ptr [ebp-14H],0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+28H]
                add     eax,edx
                fld     dword ptr [ebx]
                fsub    dword ptr [eax]
                fmul    dword ptr [ebp-18H]
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                add     eax,edx
                fadd    dword ptr [eax]
                fmul    dword ptr L68
                fstp    dword ptr [ebp-12cH]
                imul    eax,dword ptr [ebp-0cH],1cH
                fld     dword ptr [ebp-12cH]
                fadd    dword ptr L68
                fstp    dword ptr [eax+ebp-11cH]
                imul    edx,dword ptr [ebp-10H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                lea     ebx,[eax+edx]
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                add     eax,edx
                fld     dword ptr [ebx+4H]
                fsub    dword ptr [eax+4H]
                fmul    dword ptr [ebp-18H]
                imul    edx,dword ptr [ebp-14H],0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                add     eax,edx
                fadd    dword ptr [eax+4H]
                fmul    dword ptr L68
                fstp    dword ptr [ebp-12cH]
                imul    eax,dword ptr [ebp-0cH],1cH
                fld     dword ptr [ebp-12cH]
                fadd    dword ptr L68
                fstp    dword ptr [eax+ebp-118H]
L59:            mov     eax,dword ptr [ebp-0cH]
                inc     dword ptr [ebp-0cH]
L60:            jmp     near ptr L45
L61:            mov     ebx,dword ptr [ebp-0cH]
                lea     edx,[ebp-128H]
                lea     eax,[ebp-64H]
                call    near ptr MakePerspective_
                mov     ecx,00000007H
                lea     edi,[ebp-0b8H]
                lea     esi,[ebp-128H]
                repe    movsd
                mov     ecx,00000007H
                lea     edi,[ebp-9cH]
                lea     esi,[ebp-10cH]
                repe    movsd
                mov     ecx,00000007H
                lea     edi,[ebp-80H]
                lea     esi,[ebp-0f0H]
                repe    movsd
                mov     edx,dword ptr [ebp-30H]
                mov     edx,dword ptr [edx]
                lea     eax,[ebp-0b8H]
                call    near ptr m3d_TextTri32ZB_
                cmp     dword ptr [ebp-0cH],00000003H
                jle     short L62
                mov     ecx,00000007H
                lea     edi,[ebp-0b8H]
                lea     esi,[ebp-128H]
                repe    movsd
                mov     ecx,00000007H
                lea     edi,[ebp-9cH]
                lea     esi,[ebp-0f0H]
                repe    movsd
                mov     ecx,00000007H
                lea     edi,[ebp-80H]
                lea     esi,[ebp-0d4H]
                repe    movsd
                mov     edx,dword ptr [ebp-30H]
                mov     edx,dword ptr [edx]
                lea     eax,[ebp-0b8H]
                call    near ptr m3d_TextTri32ZB_
L62:            cmp     byte ptr [ebp-4H],03H
                jne     near ptr L64
                mov     eax,dword ptr [ebp-30H]
                cmp     byte ptr [eax+16H],01H
                jne     short L63
                mov     eax,dword ptr [ebp-30H]
                xor     esi,esi
                mov     si,word ptr [eax+10H]
                imul    esi,1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     esi,eax
                mov     ecx,00000007H
                lea     edi,[ebp-0b8H]
                repe    movsd
                mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+12H]
                and     eax,0000ffffH
                imul    eax,1cH
                mov     esi,dword ptr [ebp-28H]
                mov     esi,dword ptr [esi+2cH]
                add     esi,eax
                mov     ecx,00000007H
                lea     edi,[ebp-9cH]
                repe    movsd
                mov     eax,dword ptr [ebp-30H]
                xor     esi,esi
                mov     si,word ptr [eax+14H]
                imul    esi,1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     esi,eax
                mov     ecx,00000007H
                lea     edi,[ebp-80H]
                repe    movsd
                mov     edx,dword ptr [ebp-30H]
                mov     edx,dword ptr [edx]
                lea     eax,[ebp-0b8H]
                call    near ptr m3d_TextTri32ZB_
                jmp     near ptr L64
L63:            mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                imul    esi,eax,1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     esi,eax
                mov     ecx,00000007H
                lea     edi,[ebp-0b8H]
                repe    movsd
                mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+12H]
                and     eax,0000ffffH
                imul    esi,eax,1cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+2cH]
                add     esi,eax
                mov     ecx,00000007H
                lea     edi,[ebp-9cH]
                repe    movsd
                mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+14H]
                and     eax,0000ffffH
                imul    edx,eax,1cH
                mov     eax,dword ptr [ebp-28H]
                mov     esi,dword ptr [eax+2cH]
                add     esi,edx
                mov     ecx,00000007H
                lea     edi,[ebp-80H]
                repe    movsd
                mov     eax,dword ptr [ebp-30H]
                mov     ax,word ptr [eax+10H]
                and     eax,0000ffffH
                imul    eax,0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+28H]
                add     eax,edx
                fld     dword ptr [eax]
                fmul    dword ptr L69
                fadd    dword ptr L69
                fstp    dword ptr [ebp-0acH]
                mov     edx,dword ptr [ebp-30H]
                xor     eax,eax
                mov     ax,word ptr [edx+10H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+28H]
                add     eax,edx
                fld     dword ptr [eax+4H]
                fmul    dword ptr L69
                fadd    dword ptr L69
                fstp    dword ptr [ebp-0a8H]
                mov     edx,dword ptr [ebp-30H]
                xor     eax,eax
                mov     ax,word ptr [edx+12H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+28H]
                add     eax,edx
                fld     dword ptr [eax]
                fmul    dword ptr L69
                fadd    dword ptr L69
                fstp    dword ptr [ebp-90H]
                mov     eax,dword ptr [ebp-30H]
                xor     edx,edx
                mov     dx,word ptr [eax+12H]
                imul    edx,0cH
                mov     eax,dword ptr [ebp-28H]
                mov     eax,dword ptr [eax+28H]
                add     eax,edx
                fld     dword ptr [eax+4H]
                fmul    dword ptr L69
                fadd    dword ptr L69
                fstp    dword ptr [ebp-8cH]
                mov     edx,dword ptr [ebp-30H]
                xor     eax,eax
                mov     ax,word ptr [edx+14H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+28H]
                add     eax,edx
                fld     dword ptr [eax]
                fmul    dword ptr L69
                fadd    dword ptr L69
                fstp    dword ptr [ebp-74H]
                mov     edx,dword ptr [ebp-30H]
                xor     eax,eax
                mov     ax,word ptr [edx+14H]
                imul    eax,0cH
                mov     edx,dword ptr [ebp-28H]
                mov     edx,dword ptr [edx+28H]
                add     eax,edx
                fld     dword ptr [eax+4H]
                fmul    dword ptr L69
                fadd    dword ptr L69
                fstp    dword ptr [ebp-70H]
                mov     edx,dword ptr [ebp-30H]
                mov     edx,dword ptr [edx]
                lea     eax,[ebp-0b8H]
                call    near ptr m3d_TextTri32ZB_
L64:            jmp     near ptr L37
L65:            jmp     near ptr L34
L66:            mov     esp,ebp
                pop     ebp
                pop     edi
                pop     esi
                pop     edx
                pop     ecx
                pop     ebx
                ret

L67             DB      00H,00H,00H,43H
L68             DB      00H,00H,00H,43H
L69             DB      00H,00H,00H,43H
 ;===========================================================================

   temp_mtx      dd 16 dup(?)
   Scale8_4      dd 4096.0      ; 256*16
   X_Centre      dd 2560.0      ; 160*16
   Y_Centre      dd 1600.0      ; 100*16
   Value_0       dd 0.0
   Value_1       dd 1.0
   Value_min_1   dd -1.0
   sinx          dd 0
   siny          dd 0
   sinz          dd 0
   cosx          dd 0
   cosy          dd 0
   cosz          dd 0
   cam           dd 0
   temp_obj      dd 0
   world         dd 0
   ilosc_obj     dw 0
   ilosc_scian   dw 0
   visible       db 0
   u             vector <>
   v             vector <>
   n             vector <>
   punkty        vert2d<>
                 vert2d<>
                 vert2d<>

;   _NEAR_CLIP    dd 1.0
;   _NEAR_CLIP    dd 1.0009
;   _m3d_ZFrame   dw 0
; global _m3d_ZFrame:word

   Code32 EndS
   END
