;Ŀ
;  Motzel's Protected Mode DOS-extender                                     
;                                                                           
;  Vesa Library                                                             
;                                                                           
;  Author       : Bogdan Modzelewski a.k.a Motzel of Cryogen^Suspend        
;  File created : 31.12.98                                                  
;                                                                           
;

.386p
;Ŀ
; Include header file                                                       
;
include mpd.inc
include mpd_vesa.inc

;Ŀ
; Structures definition                                                     
;
VbeInfoBlock struc
 VbeSignature        dd   ?             ; VBE Signature
 VbeVersion          dw   ?             ; VBE Version
 OemStringPtr        dd   ?             ; Pointer to OEM String
 Capabilities        dd   ?             ; Capabilities of graphics cont.
 VideoModePtr        dd   ?             ; Pointer to Video Mode List
 TotalMemory         dw   ?             ; Number of 64kb memory blocks
                                        ; Added for VBE 2.0
 OEMSoftwareRev      dw   ?             ; VBE implementation Software revision
 OEMVendorNamePtr    dd   ?             ; Pointer to Vendor Name String
 OEMProductNamePtr   dd   ?             ; Pointer to Product Name String
 OEMProductRevPtr    dd   ?             ; Pointer to Product Revision String
 Reserved            db   222 dup (?)   ; Reserved for VBE implementation
                                        ; scratch area
 OemData             db   256 dup (?)   ; Data Area for OEM Strings
VbeInfoBlock ends

ModeInfoBlock   struc
 ; Mandatory information for all VBE revisions
 ModeAttributes      dw ?      ; mode attributes
 WinAAttributes      db ?      ; window A attributes
 WinBAttributes      db ?      ; window B attributes
 WinGranularity      dw ?      ; window granularity
 WinSize             dw ?      ; window size
 WinASegment         dw ?      ; window A start segment
 WinBSegment         dw ?      ; window B start segment
 WinFuncPtr          dd ?      ; pointer to window function
 BytesPerScanLine    dw ?      ; bytes per scan line

 ; Mandatory information for VBE 1.2 and above
 XResolution         dw ?      ; horizontal resolution in pixels or chars
 YResolution         dw ?      ; vertical resolution in pixels or chars
 XCharSize           db ?      ; character cell width in pixels
 YCharSize           db ?      ; character cell height in pixels
 NumberOfPlanes      db ?      ; number of memory planes
 BitsPerPixel        db ?      ; bits per pixel
 NumberOfBanks       db ?      ; number of banks
 MemoryModel         db ?      ; memory model type
 BankSize            db ?      ; bank size in KB
 NumberOfImagePages  db ?      ; number of images
 Reserved1           db ?      ; reserved for page function

 ; Direct Color fields (required for direct/6 and YUV/7 memory models)
 RedMaskSize         db ?      ; size of direct color red mask in bits
 RedFieldPosition    db ?      ; bit position of lsb of red mask
 GreenMaskSize       db ?      ; size of direct color green mask in bits
 GreenFieldPosition  db ?      ; bit position of lsb of green mask
 BlueMaskSize        db ?      ; size of direct color blue mask in bits
 BlueFieldPosition   db ?      ; bit position of lsb of blue mask
 RsvdMaskSize        db ?      ; size of direct color reserved mask in bits
 RsvdFieldPosition   db ?      ; bit position of lsb of reserved mask
 DirectColorModeInfo db ?      ; direct color mode attributes

 ; Mandatory information for VBE 2.0 and above
 PhysBasePtr         dd ?      ; physical address for flat frame buffer
 OffScreenMemOffset  dd ?      ; pointer to start of off screen memory
 OffScreenMemSize    dw ?      ; amount of off screen memory in 1k units
 Reserved2           db 206 dup (?)  ; remainder of ModeInfoBlock
ModeInfoBlock ends

;Ŀ
; Library code                                                              
;
Code32 Segment Para Public Use32 'Code'
Assume CS:Code32, DS:Code32, ES:Code32

;Ŀ
; Name: mpdDetectVesa          Trashed regs: None                          
;Ĵ
; Description: Detect for VESA presence.                                    
;Ĵ
; In   : None                                                               
; Out  : EAX - if CF is set then contains error code                        
;        Fills _mpdVideoModes table and _mpdNumberOfModes                   
;
mpdDetectVesa:
        pushad

        mov     edi, o cardinfo
        mov     eax, '2BEV'
        stosd

        Init_ES_DI cardinfo
        mov     [rm_regs.rm_EAX], 4f00h ; ax = 4f00h
        mov     ebx, 10h                ; int 10h
        mov     eax, 0300h              ; wykonaj rmode int
        mov     edi, o rm_regs
        xor     ecx, ecx
        int     31h                     ; Go !
        jnc     mdv_okee1
        mov     mpdVbeError, V_ERR_DPMI
        jmp     mdv_error_exit
mdv_okee1:

        ; sprawdzenie czy jest vesa
        mov     eax, [rm_regs.rm_EAX]
        cmp     al, 4fh
        je      mdv_okee2
        mov     mpdVbeError, V_ERR_NO_VESA
        jmp     mdv_error_exit
mdv_okee2:

        ; sprawdzenie czy funkcja nie zwrocila bledu
        cmp     ah, 0
        je      mdv_okee3
        mov     mpdVbeError, V_ERR_GENERIC_VESA
        jmp     mdv_error_exit
mdv_okee3:

        ; sprawdzenie czy napewno jest vesa
        mov     esi, o cardinfo
        cmp     d [esi.VbeSignature], 'ASEV'
        je      mdv_okee4
        mov     mpdVbeError, V_ERR_NO_VESA
        jmp     mdv_error_exit
mdv_okee4:

        ; przeksztalcenie wskaznikow z rmode do pmode
        xor     eax, eax
        xor     edx, edx
        mov     ax, w [esi.VideoModePtr]
        mov     dx, w [esi.VideoModePtr+2]
        shl     edx, 4
        add     edx, eax
        sub     edx, [Code32Addr]       ; w edx mamy wskaznik do listy trybow
        mov     d [esi.VideoModePtr], edx

        xor     eax, eax
        mov     ax, [esi.TotalMemory]   ; ilosc pamieci w blokach po 64kb
        mov     ebx, 65536
        mul     ebx
        mov     _mpdVbeTotalMem, eax

        ; pobranie informacji o wszystkich trybach video
        xor     edx, edx
        mov     edi, o _mpdVideoModes
        mov     esi, [esi.VideoModePtr]
getmodesloop:
        lodsw
        cmp     ax, 0ffffh
        jz      allmodes

        call    mpdVbeGetModeInfo
        jc      getmodesloop

        mov     ebx, o modeinfo

        mov     cl, [ebx.MemoryModel]
        cmp     cl, 4                   ; tryby 256 kolorowe
        jnz     nie_256
        jmp     tryb_graficzny
nie_256:
        cmp     cl, 6                   ; tryby 15/16/24 bitowe
        jnz     getmodesloop

        cmp     [ebx.BitsPerPixel], 16
        jnz     tryb_graficzny

        xor     ecx, ecx
        mov     cl, [ebx.RedMaskSize]   ;\
        add     cl, [ebx.GreenMaskSize] ;  na moim Tridencie bez univbe tryby
        add     cl, [ebx.BlueMaskSize]  ;  15 bit maja bpp=16  WHY ???
        mov     [ebx.BitsPerPixel], cl  ;/
tryb_graficzny:
        stosw

        mov     ax, [ebx.XResolution]
        stosw

        mov     ax, [ebx.YResolution]
        stosw

        xor     eax, eax
        mov     al, [ebx.BitsPerPixel]
        stosw

        inc     edx
        jmp     getmodesloop

allmodes:
        mov     [_mpdNumberOfModes], edx

        popad
        clc
        ret

mdv_error_exit:
        popad
        mov     eax, mpdVbeError
        stc
        ret

;Ŀ
; Name: mpdInitMode            Trashed regs: None                          
;Ĵ
; Description: Sets video mode with specified resolution. If LFB is         
;              available then automatically adds 4000h to mode number.      
;Ĵ
; In   : EAX - struct: dw reserved, resX, resY, bpp                         
; Out  : EAX - if CF is set then contains error code                        
;        Fills ModeInfoBlock struct.                                        
; WARNING: IF MAPPING LFB FAILS THEN SETS DESIRED VIDEO MODE WITHOUT LFB    
;          AND EXIT WITH ERROR CODE (V_ERR_LFB_MAPPING)!  CALLER MAY CHECK  
;          ERROR CODE IN THIS SITUATION AND EITHER PLAYS WITH BANKED MODE,  
;          OR GIVES ERROR MESSAGE AND STOPS THE PROGRAM.                    
;
mpdVbeInitMode:
        pushad

        xor     ecx, ecx
        mov     ebx, eax
        mov     esi, o _mpdVideoModes
        mov     ecx, _mpdNumberOfModes
initloop:
        mov     ax, w [ebx + 2]
        cmp     ax, w [esi+2]
        jnz     badmode
        mov     ax, w [ebx + 4]
        cmp     ax, w [esi + 4]
        jnz     badmode
        mov     ax, w [ebx + 6]
        cmp     ax, w [esi + 6]
        jz      modefound
badmode:
        add     esi, 8
        loop    initloop

        popad
        mov     eax, V_ERR_NO_VESA_MODE
        stc
        ret

modefound:
        mov     ax, [esi]
        call    mpdVbeGetModeInfo
        jc      ierror_exit

        ; sprawdzenie czy jest LFB i jesli jest dodanie 4000h do trybu
        mov     esi, o modeinfo
        and     [esi.ModeAttributes], 80h
        jz      brak_lfb
        or      eax, 04000h
        push    eax
        call    mpdMapLFB
        pop     eax                     ; nie zmienia flag
        jnc     brak_lfb
        mov     mpdVbeError, V_ERR_LFB_MAPPING
;        and     eax, NOT 04000h
brak_lfb:
        call    mpdVbeSetMode
        jc      ierror_exit

        cmp     mpdVbeError,V_ERR_LFB_MAPPING
        jz      ierror_exit

        popad
        clc
        ret

ierror_exit:
        popad
        mov     eax, mpdVbeError
        stc
        ret

;Ŀ
; Name: mpdVbeGetModeInfo      Trashed regs: None                          
;Ĵ
; Description: Gets information about video mode                            
;Ĵ
; In   : EAX - mode to get info about                                       
; Out  : EAX - if CF is set then contains error code                        
;        Fills ModeInfoBlock struct.                                        
;
mpdVbeGetModeInfo:
        pushad

        mov     [rm_regs.rm_ECX], eax
        Init_ES_DI modeinfo
        mov     [rm_regs.rm_EAX], 4f01h ; ax = 4f01h
        mov     ebx, 10h                ; int 10h
        mov     eax, 0300h              ; wykonaj rmode int
        mov     edi, o rm_regs
        xor     ecx, ecx
        int     31h                     ; Go !
        jnc     mgm_okee1
        mov     mpdVbeError, V_ERR_DPMI
        jmp     mgm_error_exit
mgm_okee1:

        ; sprawdzenie czy jest vesa
        mov     eax, [rm_regs.rm_EAX]
        cmp     al, 04fh
        je      mgm_vesa_present
        mov     mpdVbeError, V_ERR_NO_VESA
        jmp     mgm_error_exit
mgm_vesa_present:

        ; sprawdzenie czy funkcja vesy nie zwrocila bledu
        cmp     ah, 0
        je      mgm_no_func_err
        mov     mpdVbeError, V_ERR_NO_VESA_MODE
        jmp     mgm_error_exit
mgm_no_func_err:

        ; sprawdzenie czy tryb jest dostepny
        mov     esi, o modeinfo
        mov     ax, [esi.ModeAttributes]
        and     eax, 01h
        jnz     mgm_mode_present
        mov     mpdVbeError, V_ERR_NO_VESA_MODE
        jmp     mgm_error_exit

mgm_mode_present:
        popad
        clc
        ret

mgm_error_exit:
        popad
        stc
        mov     eax, mpdVbeError
        ret

;Ŀ
; Name: mpdVbeSetMode          Trashed regs: None                          
;Ĵ
; Description: Sets specified video mode                                    
;Ĵ
; In   : AX - mode to set                                                   
; Out  : EAX - if CF is set then contains error code                        
;        Fills ModeInfoBlock struct.                                        
;
mpdVbeSetMode:
        pushad

        mov     [rm_regs.rm_EAX], 4f02h ; ax = 4f00h
        mov     [rm_regs.rm_EBX], eax   ; tryb do ustawienia
        mov     ebx, 10h                ; int 10h
        mov     eax, 0300h              ; wykonaj rmode int
        mov     edi, o rm_regs
        xor     ecx, ecx
        int     31h                     ; Go !
        jnc     mvs_okee1
        mov     mpdVbeError, V_ERR_DPMI
        jmp     mvs_error_exit
mvs_okee1:

        ; sprawdzenie czy jest vesa
        mov     eax, d [rm_regs.rm_EAX]
        cmp     al, 04fh
        je      mvs_vesa_present
        mov     mpdVbeError, V_ERR_NO_VESA
        jmp     mvs_error_exit
mvs_vesa_present:

        ; sprawdzenie czy funkcja vesy nie zwrocila bledu
        cmp     ah, 0
        je      mvs_no_func_err
        mov     mpdVbeError, V_ERR_NO_VESA_MODE
        jmp     mvs_error_exit

mvs_no_func_err:
        popad
        clc
        ret

mvs_error_exit:
        popad
        mov     eax, mpdVbeError
        stc
        ret

;Ŀ
; Name: mpdVbeSetBank          Trashed regs: None                          
;Ĵ
; Description: Sets specified vesa bank number                              
;Ĵ
; In   : EAX - bank to set                                                  
; Out  : EAX - if CF is set then contains error code                        
;        Fills ModeInfoBlock struct.                                        
;
mdeVbeSetBank:
        pushad
        and     eax, 0ffffh

        cmp     eax, mpdCurrentBank
        jz      msb_no_func_err

ustaw:
        mov     mpdCurrentBank, eax

        mov     [rm_regs.rm_EAX], 4f05h ; ax = 4f05h
        mov     [rm_regs.rm_EBX], 0
        mov     [rm_regs.rm_EDX], eax
        mov     ebx, 10h                ; int 10h
        mov     eax, 0300h              ; wykonaj rmode int
        mov     edi, o rm_regs
        xor     ecx, ecx
        int     31h                     ; Go !
        jnc     msb_okee1
        mov     mpdVbeError, V_ERR_DPMI
        jmp     msb_error_exit
msb_okee1:

        ; sprawdzenie czy jest vesa
        mov     eax, d [rm_regs.rm_eax]
        cmp     al, 04fh
        je      msb_vesa_present
        mov     mpdVbeError, V_ERR_NO_VESA
        jmp     msb_error_exit
msb_vesa_present:
        ; sprawdzenie czy funkcja vesy nie zwrocila bledu
        cmp     ah, 0
        je      msb_no_func_err
        mov     mpdVbeError, V_ERR_GENERIC_VESA
        jmp     msb_error_exit

msb_no_func_err:
        popad
        clc
        ret

msb_error_exit:
        popad
        mov     eax, mpdVbeError
        stc
        ret

;Ŀ
; Name: mpdMapLFB              Trashed regs: None                          
;Ĵ
; Description: Maps linear frame buffer.                                    
;Ĵ
; In   : _mpdVbeTotalMem - how much memory to be mapped                     
; Out  : EAX - if CF is set then contains error code                        
;        Fills _mpdLFBAddress                                               
;
mpdMapLFB:
        cmp     _mpdLFBAddress, 0
        jnz     ok_map

        mov     esi, o modeinfo
        mov     ebx, [esi.PhysBasePtr]
        cmp     _mpdSystem, DPMI
        jnz     bez_dpmi

        mov     ecx, ebx
        shr     ebx, 16                 ; w bx:cx adres obszaru
        mov     esi, _mpdVbeTotalMem    ;\
        mov     edi, esi                ; w si:di wielkosc obszaru do alokacji
        shr     esi, 16                 ;/
        mov     eax, 0800h
        int     31h
        jc      blad_mapowania
        shl     ebx, 16
        mov     bx, cx
bez_dpmi:
        sub     ebx, [Code32Addr]
        mov     _mpdLFBAddress, ebx
ok_map:
        clc
        ret

blad_mapowania:
        stc
        ret


mpdSetTextMode  proc
        mov     [rm_regs.rm_EAX], 03h
        mov     ebx, 10h
        mov     eax, 0300h
        mov     edi, o rm_regs
        xor     ecx, ecx
        int     31h
        ret
mpdSetTextMode  endp


;Ŀ
; Library data                                                              
;
align 4
cardinfo                VbeInfoBlock <>   ; db 512 dup(0)
modeinfo                ModeInfoBlock <>  ; db 256 dup(0)

_mpdLfbAddress          dd 0
_mpdVideoModes          dw 512*4 dup (0)
_mpdNumberOfModes       dd 0
_mpdVbeTotalMem         dd 0
mpdCurrentBank          dd 0
mpdVbeError             dd 0

Code32  EndS
End
